/**
 * Copyright © CENRA (2016)
 *
 * remi.clement@espaces-naturels.fr
 * 
 * This software is a multi-platform and portable application based on 
 * the scientifical toolbox to monitor wetlands. With this toolbox it’s 
 * possible to calculate indicators «RhoMéO» to monitor quality, 
 * fonctionalities and urban and agricultural pressures of wetlands. 
 * Indicators are calculated using naturalist data entered and/or imported,
 * and geographic data downloaded from a geographic server.
 * 
 * This software is governed by the CeCILL license under French law and
 * abiding by the rules of distribution of free software.  You can  use, 
 * modify and/ or redistribute the software under the terms of the CeCILL
 * license as circulated by CEA, CNRS and INRIA at the following URL
 * "http://www.cecill.info". 
 * 
 * As a counterpart to the access to the source code and  rights to copy,
 * modify and redistribute granted by the license, users are provided only
 * with a limited warranty  and the software's author,  the holder of the
 * economic rights,  and the successive licensors  have only  limited
 * liability. 
 * 
 * In this respect, the user's attention is drawn to the risks associated
 * with loading,  using,  modifying and/or developing or reproducing the
 * software by the user in light of its specific status of free software,
 * that may mean  that it is complicated to manipulate,  and  that  also
 * therefore means  that it is reserved for developers  and  experienced
 * professionals having in-depth computer knowledge. Users are therefore
 * encouraged to load and test the software's suitability as regards their
 * requirements in conditions enabling the security of their systems and/or 
 * data to be ensured and,  more generally, to use and operate it in the 
 * same conditions as regards security. 
 * 
 * The fact that you are presently reading this means that you have had
 * knowledge of the CeCILL license and that you accept its terms.
*/
package fr.cenra.rhomeo.core.result;

import fr.cenra.rhomeo.api.process.Indicator;
import fr.cenra.rhomeo.api.result.Index;
import fr.cenra.rhomeo.api.result.IndexSpi;
import fr.cenra.rhomeo.core.data.MockIndicator;
import java.util.Collection;
import java.util.Collections;
import java.util.Objects;
import javax.measure.unit.Unit;
import org.apache.sis.util.ArgumentChecks;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Component;

/**
 *
 * @author Alexis Manin (Geomatys)
 */
@Component
public class MockAnnualIndexSpi implements IndexSpi<Integer, Integer> {

    @Autowired
    @Qualifier(MockIndicator.NAME)
    Indicator i;

    @Override
    public Unit<?> getUnit() {
        return Unit.ONE;
    }

    @Override
    public Indicator getIndicator() {
        return i;
    }

    @Override
    public MockAnnualIndex createIndex(Integer value, Integer entity) {
        return new MockAnnualIndex(value, entity == null? 0 : entity);
    }

    @Override
    public String getName() {
        return "\"Mock annual SPI\"";
    }

    @Override
    public Collection<String> getAlias() {
        return Collections.EMPTY_SET;
    }

    @Override
    public String getRemarks() {
        return "A mock index for test purposes.";
    }

    public class MockAnnualIndex implements Index<Integer> {

        private final Integer value;
        private final int year;

        public MockAnnualIndex(Integer value, int year) {
            ArgumentChecks.ensureNonNull("Value", value);
            this.value = value;
            this.year = year;
        }

        @Override
        public Integer getValue() {
            return value;
        }

        @Override
        public int getYear() {
            return year;
        }

        @Override
        public IndexSpi getSpi() {
            return MockAnnualIndexSpi.this;
        }

        @Override
        public int hashCode() {
            int hash = 7;
            hash = 31 * hash + Objects.hashCode(this.value);
            hash = 31 * hash + this.year;
            return hash;
        }

        @Override
        public boolean equals(Object obj) {
            if (this == obj)
                return true;
            if (obj == null)
                return false;
            if (getClass() != obj.getClass())
                return false;

            final MockAnnualIndex other = (MockAnnualIndex) obj;
            return this.year == other.year && Objects.equals(this.value, other.value);
        }
    }
}
